*!*	FieldNum()    ,         .
*!*	FieldNum(tcFieldName[,  tcAlias | nWorkArea])
*!*	   
*!*	
*!*	  tcFieldName     ,     ,
*!*	    ,   0.
*!*	  () 
*!*	tcAlias     ,
*!*	--
*!*	nWorkArea      FIELDNUM( ),
*!*	        ,      0,
*!*	       ,
*!*	         ,   0.
*!*	          ,   ,
*!*	    ,   0.
*!*	:
*!*	Clear
*!*	Close Database
*!*	Open Database (Home(2) + 'data\testdata') Noupdate
*!*	Use customer Noupdate && Opens Customer table
*!*	*        city  phone   customer
*!*	*    UNION,         ORDER BY,
*!*	*      ,       
*!*	pcOrderBy = Str(FieldNum([city],[ customer]))+[,]+Str(FieldNum([phone],[customer]))
*!*	Select customer.*, orders.order_id, orders.emp_id ;
*!*	   From customer, orders  Where customer.cust_id = orders.cust_id ;
*!*	   Union  Select customer.*, Space(Len(orders.order_id)), Space(Len(orders.emp_id)) ;
*!*	   From customer  Where customer.cust_id Not In ;
*!*	   (Select orders.cust_id From orders) Order By &pcOrderBy Into Cursor CurTest
*!*	For gnCount = 1 To Fcount( )  && Loop for number of fields
*!*	   ? FieldNum(Field(gnCount)), Field(gnCount)   && Display each number of field and field
*!*	Endfor
Function FieldNum
   **      
   Parameters tcFieldName, tcAlias
   * tcFieldName -  
   * tcAlias -   ,  
   *         
   If Parameters()=1
      tcAlias=Alias()
   Else
      If Type([tcAlias])<>[]
         tcAlias=Alias()
      Else
         tcAlias=Alltrim(Upper(tcAlias))
      Endif
   Endif
   Private All
   tcFieldName=Alltrim(Upper(tcFieldName))
   pnFieldNum = 0
   If .Not.Empty(Used(tcAlias))
      For pnI=1 To Fcount(tcAlias)
         If Field(pnI,tcAlias)==tcFieldName
            pnFieldNum = pnI
            Exit
         Endif
      Endfor
   Endif
   Return pnFieldNum


   *------------------------      ---------------------------------

   *!*	ARRAYSUM (@ArrayName, [nSearchColumn [, nStartRow [, nRowsSearched]]] )
   *!*	   ()    
   *!*	    ()  
   *!*	  ArrayName  ,   ,        @.
   *!*	 ()  nSearchColumn  ,  ,      ,      .
   *!*	 ()  nStartRow  ,  ,      ,       .
   *!*	 ()  nRowsSearched  ,  ,   nStartRow,     ,      , , .
   *!*	 1    , , ,      nRowsSearched,   ,   .
Function ARRAYSUM
   Lparameters ArrayName, nSearchColumn, nStartRow, nRowsSearched
   Return ArrayFun(@ArrayName,'Sum', nSearchColumn, nStartRow, nRowsSearched)


   *!*	ARRAYAVG (@ArrayName, [nSearchColumn [, nStartRow [, nRowsSearched]]] )
   *!*	    ()    
   *!*	   () 
   *!*	  ArrayName  ,   ,        @.
   *!*	 ()  nSearchColumn  ,  ,       ,           .
   *!*	 ()  nStartRow  ,  ,        ,         .
   *!*	 ()  nRowsSearched  ,  ,   nStartRow,       ,        , , .
   *!*	 1    , , ,      nRowsSearched,   ,   .
Function ARRAYAVG
   Lparameters ArrayName, nSearchColumn, nStartRow, nRowsSearched
   Return ArrayFun(@ArrayName,'Avg', nSearchColumn, nStartRow, nRowsSearched)


   *!*	ARRAYMAX (@ArrayName, [nSearchColumn [, nStartRow [, nRowsSearched [, @NumRowWithMaxElem]]]] )
   *!*	      .
   *!*	  , ,  ,  , ,  
   *!*	  ArrayName  ,   ,         @.
   *!*	 ()  nSearchColumn  ,  ,       ,       .
   *!*	 ()  nStartRow  ,  ,      ,       .
   *!*	 ()  nRowsSearched  ,  ,   nStartRow,     ,
   *!*	     , , .
   *!*	 ()  NumRowWithMaxElem,   
   *!*	,      ,   .
   *!*	 1    , , ,      NumRowWithMaxElem,   ,   .
Function ARRAYMAX
   Lparameters ArrayName, nSearchColumn, nStartRow, nRowsSearched, NumRowWithMaxElem
   Return ArrayFun(@ArrayName,'Max', nSearchColumn, nStartRow, nRowsSearched, @NumRowWithMaxElem)


   *!*	ARRAYMIN (@ArrayName, [nSearchColumn [, nStartRow [, nRowsSearched [, @NumRowWithMinElem]]]] )
   *!*	      .
   *!*	  , ,  ,  , ,  
   *!*	  ArrayName  ,   ,         @.
   *!*	 ()  nSearchColumn  ,  ,       ,       .
   *!*	 ()  nStartRow  ,  ,      ,       .
   *!*	 ()  nRowsSearched  ,  ,   nStartRow,     ,
   *!*	     , , .
   *!*	 ()  NumRowWithMinElem,   
   *!*	,      ,   .
   *!*	 1    , , ,      NumRowWithMinElem,      .
Function ARRAYMIN
   Lparameters ArrayName, nSearchColumn, nStartRow, nRowsSearched, NumRowWithMinElem
   Return ArrayFun(@ArrayName,'Min', nSearchColumn, nStartRow, nRowsSearched, @NumRowWithMinElem)

   *!*	ARRAYCNT (@ArrayName, [nSearchColumn [, nStartRow [, nRowsSearched]]] )
   *!*	  ArrayName  ,   ,        @.
   *!*	 ()  nSearchColumn  ,  ,        () ,         .
   *!*	 ()  nStartRow  ,  ,         () ,       .
   *!*	 ()  nRowsSearched  ,  ,   nStartRow,     ,      , , .
   *!*	 1    , , ,      nRowsSearched,   ,   .
Function ARRAYCNT
   Lparameters ArrayName, nSearchColumn, nStartRow, nRowsSearched
   Return ArrayFun(@ArrayName,'Cnt', nSearchColumn, nStartRow, nRowsSearched)

   *!*	GETALLWORDS()          memo ,      ,     ,  0.
   *!*	GETALLWORDS(ArrayName, lcString[, lcDelimiters])
   *!*	   
   *!*	    
   *!*	 ,          lcString
   *!*	 ,   - 
   *!*	 ,       lcString,    
   *!*	 ,   -  
   *!*	
   *!*	ArrayName        
   *!*	lcString    ,      ,       ,    ,
   *!*	      memo .
   *!*	lcDelimiters  ,   256  -   ,
   *!*	  ,         lcString.
   *!*	    ,  ,     .
   *!*	GETALLWORDS()       lcDelimiters   ,     lcDelimiters    .
Function GETALLWORDS
   Lparameters lArrayName, cString, cDelimiters
   Return getallwords__(lArrayName, cString, cDelimiters, .T.)

Function GETALLWORDS2
   Lparameters lArrayName, cString, cDelimiters
   Return getallwords__(lArrayName, cString, cDelimiters, .F.)


Function getallwords__
   Lparameters lArrayName, cString, cDelimiters, tlWhat
   *!*	     
   *!*	   
   *!*	   
   *!*	        
   *!*	    
   *!*	    cString  - cDelimiters
   *!*        cString
   Local All
   maxlengthword = 0
   Release (lArrayName)
   If Empty(cString)
      Return 0
   Else
      If Type('cDelimiters')<>'C'
         cDelimiters = Iif(tlWhat , Space(1)+Chr(9)+Chr(10)+Chr(13), Space(1))
      Else
         If .Not.tlWhat And Empty(cDelimiters )
            cDelimiters =  Space(1)
         Endif
      Endif
      Do Case
      Case Len(cDelimiters) = 0
         Dimension laArray(1,4)
         laArray(1,1) = 1
         laArray(1,2) = cString
         laArray(1,3) = 1
         laArray(1,4) = Len(cString)
         maxlengthword = Len(cString)
      Case Len(cDelimiters) >= 1
         If tlWhat &&         
            lcOnecDelimiter = Left(cDelimiters,1)
            cString = Chrtran(cString , Substr(cDelimiters,2), Replicate(lcOnecDelimiter, Len(cDelimiters) - 1))
            cDelimiters = lcOnecDelimiter
         Endif
         lnPos = 1
         lnI = 0
         wordcount = 1
         Store 1 To k, BegOfWord
         plExit = .F.
         Dimension laArray(65000,4)
         Do While .T.
            If  k > BegOfWord
               * Dimension laArray(wordcount,4)
               laArray[wordcount,1] = wordcount
               laArray[wordcount,3] = BegOfWord   && begin of previous word
               laArray[wordcount,4] = k-BegOfWord && length of previous word
               laArray[wordcount,2] = Substr(cString, laArray[wordcount,3], laArray[wordcount,4])
               If maxlengthword < laArray[wordcount, 4]
                  maxlengthword = laArray[wordcount, 4]
               Endif
               wordcount = wordcount + 1
               BegOfWord = k
            Endif
            If plExit
               Exit
            Endif
            Do While cDelimiters == Substr(cString,k,Len(cDelimiters))
               k = k + Len(cDelimiters)
               BegOfWord = k
            Enddo

            lnPos = At(cDelimiters, Substr(cString,k),1)
            If Empty(lnPos)
               plExit = .T.
               k = Len(cString) + 1
            Else
               k = k + lnPos - 1
            Endif
         Enddo
         If .Not.Empty(maxlengthword)
            Dimension laArray(wordcount-1,4)
         Endif
      Endcase
      If .Not.Empty(maxlengthword)
         Public Array (lArrayName+'(1)')
         =Acopy(laArray, (lArrayName))
      Endif
      Return maxlengthword
   Endif

   *    GETALLWORDS
   *!*	GETALLWORDS()          memo ,      ,     ,  0.
   *!*	GETALLWORDS(ArrayName, lcString[, lcDelimiters])
   *!*	   
   *!*	    
   *!*	 ,          lcString
   *!*	 ,   - 
   *!*	 ,       lcString,    
   *!*	 ,   -  
   *!*	
   *!*	ArrayName        
   *!*	lcString    ,      ,       ,    ,
   *!*	      memo .
   *!*	lcDelimiters  ,   256  -   ,
   *!*	  ,         lcString.
   *!*	    ,  ,     .
   *!*	GETALLWORDS()       lcDelimiters   ,     lcDelimiters    .
Function GETALLWORDS1 &&    GETALLWORDS
   Lparameters laArray, cString, cDelimiters
   *!*	      
   *!*	   
   *!*	   
   *!*	        
   *!*	    
   *!*	    cString  - cDelimiters
   Local All
   lnMaxLenWord = 0
   If Empty(cString)
      Dimension laArray(1)
      laArray(1) = .F.
   Else
      If Type('cDelimiters')<>'C'
         cDelimiters =  Space(1)+Chr(9)+Chr(10)+Chr(13)
      Endif
      Do Case
      Case Len(cDelimiters) = 0
         Dimension laArray(1,4)
         laArray(1,1) = 1
         laArray(1,2) = cString
         laArray(1,3) = 1
         laArray(1,4) = Len(cString)
         lnMaxLenWord = laArray(1,4)
      Case Len(cDelimiters) >= 1
         lnWordCnt = Getwordcount(cString, cDelimiters)
         If .Not.Empty(lnWordCnt)
            Dimension laArray(lnWordCnt,4)
            For lnI = 1 To lnWordCnt
               **            ,  
               **        +     + 1
               lnEndPrevWord =  Iif(lnI>1, laArray(lnI-1,3)+laArray(lnI-1,4) + 1 ,1)
               laArray(lnI,1) = lnI
               laArray(lnI,2) = Getwordnum(Substr(cString, lnEndPrevWord ), 1, cDelimiters)
               laArray(lnI,4) = Len(laArray(lnI,2))
               If laArray(lnI,4) > lnMaxLenWord
                  lnMaxLenWord = laArray(lnI,4)
               Endif
               laArray(lnI,3) = At(laArray(lnI,2), Substr(cString, lnEndPrevWord )) + lnEndPrevWord - 1
            Endfor
         Else
            Dimension laArray(1)
            laArray(1) = .F.
         Endif
      Endcase
   Endif
   Return lnMaxLenWord

   ** The maximum number of strings permitted in cParseChar is 23
   #Define NUMBEROFSTRINGSPERMITTEDINCPARSECHAR 23

Function getnumword
   ** GetNumWord(cString, cWord[, cDelimiters] [, nOccurrence] [, nFlags])
   ** Return Value  Numeric
   ** Returns the index position of the word specified by cWord in the target string, cString.
   ** If cString don't contain the word cWord, GetNumWord( ) returns 0.

   *!*  cString Specifies the string to be evaluated
   *!*  cWord Specifies the word to search for in cString.
   *!*  cDelimiters Optional. Specifies one or more optional characters used to separate words in cString.
   *!*  The default delimiters are space, tab, carriage return, and line feed.
   *!*  Note that GetNumWord( ) uses each of the characters in cDelimiters as individual delimiters, not the entire string as a single delimiter.
   *!*  nOccurrence Specifies which occurrence, first, second, third, and so on, of cWord to search for in cString.
   *!*  By default, GetNumWord( ) searches for the first occurrence of cWord (nOccurrence = 1).
   *!*  nFlags  Specifies Case-sensitive search criteria To Apply To This Function. Valid Values are 0 (the Default) And 1.
   *!*  0 Case-sensitive search
   *!*  1 Case insensitive search

   Lparameters cString, cWord, cDelimiters, nOccurrence, nFlags
   If Type("cString")<>"C"
      cString = ""
   Endif
   If Type("cWord")<>"C"
      cWord = ""
   Endif
   If Type("cDelimiters")<>"C"
      cDelimiters = Space(1)+Chr(9)+Chr(10)+Chr(13)
   Endif
   If Type("nOccurrence")<>"N" Or nOccurrence < 1
      nOccurrence = 1
   Endif
   If Type("nFlags")<>"N" Or nFlags <> 1
      nFlags = 0
   Endif

   Local lnI, lcCommand, cParseChar, lnElem, lnOccurrence,  lnResult
   Local Array laArray(1)
   Store 0 To lnOccurrence, lnElem, lnResult
   cParseChar = ""

   lcCommand = "ALINES(laArray, cString, 4 "
   For lnI = 1 To Min(Len(cDelimiters), NUMBEROFSTRINGSPERMITTEDINCPARSECHAR)
      cParseChar = cParseChar + ",Chr("+ Alltrim(Str(Asc(Substr(cDelimiters, lnI, 1))))+")"
   Endfor
   lcCommand = lcCommand + cParseChar +Iif(Empty(cDelimiters),[,""],[]) +[)]
   Local lnRow
   lnRow = &lcCommand
   If .Not.Empty(lnRow)
      Do While lnOccurrence < nOccurrence
         lnElem = lnElem + 1
         lnElem = Ascan(laArray, cWord, lnElem, -1, 1, nFlags + 2 + 4 + 8 )
         If .Not.Empty(lnElem)
            If Iif(Empty(nFlags), laArray(lnElem) == cWord, Lower(laArray(lnElem)) == Lower(cWord))
               lnOccurrence = lnOccurrence + 1
            Endif
         Else
            Exit
         Endif
      Enddo
      If lnOccurrence = nOccurrence
         lnResult = lnElem
      Endif
   Endif
   Return lnResult

Function ArrayFun
   Parameters taArray, tcWhat, tnColumn, tnStartRow, tnRows, tnNumberOfElem
   ** tnNumberOfElem   
   **   'MIN','MAX'   
   **    ()    
   **         
   Private All
   tnNumberOfElem = 0 &&   ()  ,      ,   0
   plFlags = .F. &&       
   If Type('taArray(1)')=='U'
      Return .F.
   Endif
   If Type('tcWhat')<>'C'
      tcWhat = 'SUM'
   Endif
   tcWhat = Alltrim(Upper(tcWhat))
   If .Not.Inlist(tcWhat,'SUM','CNT','AVG','MIN','MAX')
      tcWhat = 'SUM'
   Endif
   If Type('tnColumn')<>'N' Or Alen(taArray, 2) = 0 &&  
      tnColumn = 1
   Endif
   If tnColumn<=0
      *       <=0,           
      tnColumn = 1
      plFlags = .T.
   Endif

   If Type('tnStartRow')<>'N' Or tnStartRow < 0
      tnStartRow = 1
   Endif
   If Type('tnRows')<>'N'  Or tnRows < 0
      tnRows = Alen(taArray, 1)
   Endif
   If tnStartRow > Alen(taArray, 1)
      Return .F.
   Endif
   If tnStartRow+tnRows-1 > Alen(taArray, 1)
      tnRows = Alen(taArray, 1) - tnStartRow + 1
   Endif

   tnRows = tnStartRow+tnRows-1
   Store 0 To pnCounter, pnSum, pnMin, pnMax, NumberOfElemMin, NumberOfElemMax
   Store 0 To pnCounterDateTime, pnCounterCaracter
   Store 0 To NumberOfElemMinDateTime , NumberOfElemMaxDateTime, NumberOfElemMinCaracter, NumberOfElemMaxCaracter

   pnFlagDateTime = .F.
   pnFlagNum  = .F.

   For pnJ = Iif(plFlags And .Not.Empty(Alen(taArray, 2)), 1, tnColumn) To ;
         iif(plFlags And .Not.Empty(Alen(taArray, 2)), Alen(taArray, 2), tnColumn)

      For pnI = tnStartRow To tnRows
         Do Case
         Case Inlist(Type('taArray(pnI, pnj)'),'N','Y')
            If Type('taArray(pnI, pnj)') = 'N' &&           
               pnFlagNum  = .T.
            Endif
            If pnFlagNum
               If Type('pnMin') = 'Y'
                  pnMin = Mton(pnMin)
               Endif
               If Type('pnMax ') = 'Y'
                  pnMax = Mton(pnMax )
               Endif
               If Type('pnSum') = 'Y'
                  pnSum = Mton(pnSum)
               Endif
               pnNumElem = Iif(Type('taArray(pnI, pnj)') = 'Y', Mton(taArray(pnI, pnJ)), taArray(pnI, pnJ))
            Else
               pnNumElem = taArray(pnI, pnJ)
            Endif
            If Empty(pnCounter)
               Store pnNumElem  To pnSum, pnMin, pnMax
               Store pnI To NumberOfElemMin, NumberOfElemMax
            Else
               If taArray(pnI, pnJ) < pnMin
                  Store pnI To NumberOfElemMin
               Endif
               If taArray(pnI, pnJ) > pnMax
                  Store pnI To NumberOfElemMax
               Endif
               pnMin = Min(pnNumElem , pnMin)
               pnMax = Max(pnNumElem , pnMax)
               pnSum = pnSum + pnNumElem
            Endif
            pnCounter = pnCounter + 1
         Case Inlist(Type('taArray(pnI, pnj)'),'C') And Inlist(tcWhat, 'MIN', 'MAX')
            If Empty(pnCounterCaracter)
               Store taArray(pnI, pnJ) To pcMin, pcMax
               Store pnI To NumberOfElemMinCaracter, NumberOfElemMaxCaracter
            Else
               If taArray(pnI, pnJ) < pcMin
                  Store pnI To NumberOfElemMinCaracter
               Endif
               If taArray(pnI, pnJ) > pcMax
                  Store pnI To NumberOfElemMaxCaracter
               Endif
               pcMin = Min(taArray(pnI, pnJ), pcMin)
               pcMax = Max(taArray(pnI, pnJ), pcMax)
            Endif
            pnCounterCaracter = pnCounterCaracter + 1

         Case Inlist(Type('taArray(pnI, pnj)'),'D','T') And Inlist(tcWhat, 'MIN', 'MAX')
            If _Windows
               If Type('taArray(pnI, pnj)') = 'T'
                  pnFlagDateTime = .T.
                  ptElem = taArray(pnI, pnJ)
               Else
                  ptElem = Dtot(taArray(pnI, pnJ))
               Endif
            Else
               pnFlagDateTime = .F.
               ptElem = taArray(pnI, pnJ)
            Endif

            If Empty(pnCounterDateTime)
               Store ptElem  To pdMin, pdMax
               Store pnI To NumberOfElemMinDateTime, NumberOfElemMaxDateTime
            Else
               If ptElem  < pdMin
                  Store pnI To NumberOfElemMinDateTime
               Else
                  If ptElem  > pdMax
                     Store pnI To NumberOfElemMaxDateTime
                  Endif
               Endif
               pdMin = Min(ptElem , pdMin)
               pdMax = Max(ptElem , pdMax)
            Endif
            pnCounterDateTime = pnCounterDateTime + 1

         Endcase
      Endfor
   Endfor
   If Empty(pnCounter)
      If .Not.Empty(pnCounterCaracter)  And Inlist(tcWhat, 'MIN', 'MAX')
         tcWhat= Iif(tcWhat = 'MIN', 'MINCARACTER', 'MAXCARACTER')
      Else
         If .Not.Empty(pnCounterDateTime)  And Inlist(tcWhat, 'MIN', 'MAX')
            tcWhat= Iif(tcWhat = 'MIN', 'MINDATETIME', 'MAXDATETIME')
         Else
            If tcWhat<>'CNT'
               tcWhat='NULL'
            Endif
         Endif
      Endif
   Endif
   If pnFlagNum
      If Type('pnSum') = 'Y'
         pnSum = Mton(pnSum)
      Endif
      If Type('pnMin') = 'Y'
         pnMin = Mton(pnMin)
      Endif
      If Type('pnMax') = 'Y'
         pnMax = Mton(pnMax)
      Endif
   Endif
   Do Case
   Case tcWhat=='NULL'
      Return .F.
   Case tcWhat=='CNT'
      Return pnCounter
   Case tcWhat=='SUM'
      Return pnSum
   Case tcWhat=='AVG'
      Return Iif(Type('pnSum') == 'Y',  Ntom(Mton(pnSum)/pnCounter)  ,pnSum/pnCounter)
   Case tcWhat=='MIN'
      tnNumberOfElem = NumberOfElemMin
      Return pnMin
   Case tcWhat=='MAX'
      tnNumberOfElem = NumberOfElemMax
      Return pnMax
   Case tcWhat=='MINCARACTER'
      tnNumberOfElem = NumberOfElemMinCaracter
      Return pcMin
   Case tcWhat=='MAXCARACTER'
      tnNumberOfElem = NumberOfElemMaxCaracter
      Return pcMax
   Case tcWhat=='MINDATETIME'
      tnNumberOfElem = NumberOfElemMinDateTime
      Return Iif(pnFlagDateTime, pdMin, Ttod(pdMin))
   Case tcWhat=='MAXDATETIME'
      tnNumberOfElem = NumberOfElemMaxDateTime
      Return Iif(pnFlagDateTime, pdMax, Ttod(pdMax))
   Endcase


   *!*	   ASCAN(),   ,         
   *!*	:
   *!*	   ,  INLIST(nFlags, 1, 3, 5, 7, 9, 11, 13, 15 ) = .T. ,       ,
   *!*	           , ,
   *!*	   ASORT(ArrayName [, nStartRow[, nNumberSorted [, nSortOrder [, nFlags]]])
   *!*	      nFlags  ASORT()  1.
   *!*	 ,       nStartRow,   nRowsSearched  ,
   *!*	      ,        .
Function ASCANQUICK
   Parameter REFARRAY,QUECHERCHE,nStartElement ,nElementsSearched ,nSearchColumn, nFlags
   Private All
   External Array REFARRAY
   If Parameters()>=6
      If Type('nFlags ')<>'N'
         Wait Windows "    ( )"
         Return 0
      Else
         nFlags = Int(nFlags)
         If .Not.Between(nFlags, 0, 15)
            Wait Windows "      (   0  15)"
            Return 0
         Endif
      Endif
   Else
      nFlags = 0
   Endif

   If Parameters()>=5
      If Type('nSearchColumn ')<>'N'
         Wait Windows "    (    )"
         Return 0
         * nSearchColumn =1
      Else
         If nSearchColumn <= 0
            **  ASCAN     ,     
            **              
            nSearchColumn =1
         Else
            If nSearchColumn > Iif(Empty(Alen(REFARRAY, 2)), 1, Alen(REFARRAY, 2))
               Wait Windows "    (        )"
               Return 0
            Endif
         Endif
      Endif
   Else
      nSearchColumn = 1
   Endif
   If Parameters()>=3
      If Type('nStartElement ')<>'N'
         Wait Windows "    (    )"
         Return 0
         * nStartElement =1
      Endif
      If nStartElement = -1
         nStartElement = 1  &&       
      Else
         If  .Not.Between(nStartElement, 1, Alen(REFARRAY,1))
            Wait Windows "    (    )"
            Return 0
         Endif
      Endif
   Else
      nStartElement = 1 &&       
   Endif
   If Parameters()>=4
      If Type('nElementsSearched')<>'N'
         Wait Windows "    (     )"
         Return 0
      Endif
      If nElementsSearched = -1
         nElementsSearched = Alen(REFARRAY,1) - nStartElement + 1   &&   -           
      Else
         If  nElementsSearched > Alen(REFARRAY,1) - nStartElement + 1
            nElementsSearched = Alen(REFARRAY,1) - nStartElement + 1
         Endif
         If nElementsSearched < -1 .Or. nElementsSearched  = 0
            Wait Windows "    (     )"
            Return 0
         Endif
      Endif
   Else
      nElementsSearched =Alen(REFARRAY,1)
   Endif

   If Alen(REFARRAY,1)<nStartElement +nElementsSearched -1
      **       
      nElementsSearched =Alen(REFARRAY,1)-nStartElement +1
   Endif
   If Empty(Alen(REFARRAY,2))
      **  
      nSearchColumn = 1
   Endif
   *!*	Bit Description
   *!*	0 Case Insensitive bit
   *!*	1 Exactness ON bit (Only effective if bit 2 is set)
   *!*	2 Override system Exact setting bit
   *!*	3 Return row number if 2D array
   pnSaveExact = Set([EXACT])
   *!*	     Ascan      Set Exact,
   *!*	       comparison    nFlags,    Set Exact      nFlags
   If Bittest(nFlags, 2)
      If Bittest(nFlags, 1)
         Set Exact On
      Else
         Set Exact Off
      Endif
   Endif

   *       ASORT()    St_Denis_Russian.chm  "", "   ..."
   *  ,  Set Exact On,       ,
   *         ,   , ASCII    32.
   *            Set Exact On,   ASCAN()
   If Type('QUECHERCHE')=='C' And Empty(Len(Alltrim(QUECHERCHE))) And Set("EXACT") == "ON"
      Return Ascan( REFARRAY,QUECHERCHE, nStartElement, nElementsSearched , nSearchColumn, nFlags)
   Endif

   PNF=BSEARCHQUICK(@REFARRAY,(QUECHERCHE),(nSearchColumn ),(nStartElement ),(nElementsSearched ),(nFlags))
   SPNF=PNF
   Do While .Not.Empty(PNF)
      PNF=PNF-nStartElement
      If PNF=0
         Exit
      Endif
      PNF=BSEARCHQUICK(@REFARRAY,(QUECHERCHE),(nSearchColumn ),(nStartElement ),(PNF),(nFlags))
      If .Not.Empty(PNF)
         SPNF=PNF
      Endif
   Enddo
   Set Exact &pnSaveExact
   * bittest(nFlags, 3)  Return row number if 2D array
   Return Iif(Bittest(nFlags, 3), SPNF, Iif(Empty(Alen(REFARRAY,2)), SPNF, Iif(.Not.Empty(SPNF), Aelement(REFARRAY, SPNF, nSearchColumn ), SPNF )))


Function BSEARCHQUICK
   Parameter REFARRAY, QUECHERCHE, nColsSear, nStartRow, nRowsSear, nFlags
   Private All
   External Array REFARRAY
   Low=nStartRow
   High=nStartRow+nRowsSear-1
   MID=Int((Low+High)/2)
   *!*	Bit Description
   *!*	0 Case Insensitive bit
   *!*	1 Exactness ON bit (Only effective if bit 2 is set)
   *!*	2 Override system Exact setting bit
   *!*	3 Return row number if 2D array
   * bittest(nFlags, 0)  && Case Insensitive bit

   Do While  Low<=High
      Do Case
      Case .Not.Empty(Ascan(REFARRAY,QUECHERCHE, MID, 1, nColsSear, nFlags ))
         Exit
      Case comparison(QUECHERCHE,[>=], Iif(Empty(Alen(REFARRAY,2)),REFARRAY(MID),REFARRAY(MID,nColsSear)), nFlags )
         **  Low MID+      Low  High
         Low=MID+1
      Case comparison(QUECHERCHE,[<], Iif(Empty(Alen(REFARRAY,2)),REFARRAY(MID),REFARRAY(MID,nColsSear)), nFlags )
         **  High MID-      Low  High
         High=MID-1
      Case Empty(Ascan(REFARRAY,QUECHERCHE,MID, 1, nColsSear, nFlags))
         Exit
      Otherwise
      Endcase
      MID=Int((Low+High)/2)
      If .Not.Between(MID,nStartRow,nStartRow+nRowsSear-1)
         Exit
      Endif
   Enddo
   If .Not.Between(MID,nStartRow,nStartRow+nRowsSear-1)
      MID=0
   Else
      If Empty(Ascan(REFARRAY,QUECHERCHE,MID, 1, nColsSear, nFlags))
         MID=0
      Endif
   Endif
   Return MID


   *!*	     Asort()          
   *!*	     ( Upper),            ,      
   *!*	?ASC('Z')  && display 90
   *!*	?ASC('[')  && display 91
   *!*	?ASC('a')  && display 97
   *!*	        '[',
   *!*	       .
   *!*	    
   *!*	pnStart = 89
   *!*	For pnI = pnStart To 101
   *!*	   Dimension laTestAsort(pnI + 1 - pnStart)
   *!*	   laTestAsort(Alen(laTestAsort,1) ) = Chr(pnI)
   *!*	Endfor
   *!*	Display Memory Like laTestAsort
   *!*	
   *!*	          (   1)    C            "Y"
   *!*	          (   2)    C            "Z"
   *!*	          (   3)    C            "["
   *!*	          (   4)    C            "\"
   *!*	          (   5)    C            "]"
   *!*	          (   6)    C            "^"
   *!*	          (   7)    C            "_"
   *!*	          (   8)    C            "`"
   *!*	          (   9)    C            "a"
   *!*	          (  10)    C            "b"
   *!*	          (  11)    C            "c"
   *!*	          (  12)    C            "d"
   *!*	          (  13)    C            "e"
   *!*	=Asort(laTestAsort, -1, -1, -1, 1)
   *!*	Display Memory Like laTestAsort
   *!*	
   *!*	          (   1)    C            "a"
   *!*	          (   2)    C            "b"
   *!*	          (   3)    C            "c"
   *!*	          (   4)    C            "d"
   *!*	          (   5)    C            "e"
   *!*	          (   6)    C            "Y"
   *!*	          (   7)    C            "Z"
   *!*	          (   8)    C            "["
   *!*	          (   9)    C            "\"
   *!*	          (  10)    C            "]"
   *!*	          (  11)    C            "^"
   *!*	          (  12)    C            "_"
   *!*	          (  13)    C            "`"
   *!*	      ,       "[",
   *!*	            ,   .

   *!*	     Asort()          
   *!*	     ( Upper),            ,      
   *!*	pnStart = 32
   *!*	For pnI = pnStart To 156
   *!*	            Dimension laTestAsort(pnI + 1 - pnStart)
   *!*	            laTestAsort(Alen(laTestAsort,1) ) = Chr(pnI)
   *!*	Endfor
   *!*	Display Memory Like laTestAsort

   *!*	=Asort(laTestAsort, -1, -1, -1, 1)
   *!*	Display Memory Like laTestAsort

Function comparison
   **  .T.    (    ,   ..) 
   Lparameter  tVar1 , tcSign, tVar2, nFlags
   If Type([tVar1])==[C] And  Type([tVar2])==[C]
      If Bittest(nFlags, 0)  && Case Insensitive bit
         Return (Upper(tVar1) &tcSign Upper(tVar2)) &&   Upper,   Lower !
      Endif
   Endif
   Return (tVar1 &tcSign tVar2)

   *!*	VITESCAN(@ArrayName, eExpression [, nSearchColumn [, nStartRow[, nRowsSearched]]])
   *!*	 VITESCAN     eExpression       ,    .    ,    ,   ,       0.
   *!*	  ArrayName  ,     ,     ,         @.
   *!*	   eExpression  - ,        ArrayName.
   *!*	 ()  nSearchColumn  ,  ,       eExpression,
   *!*	 ,     nSearchColumn =  -1,       ArrayName.
   *!*	 nSearchColumn     ,    nSearchColumn  -1,       .  ()  nStartRow  ,     ,      ,        .
   *!*	  ()  nRowsSearched  ,  ,   nStartRow,     ,       .
   *!*	           nStartRow  nRowsSearched.
   *!*	 1    , , ,      nRowsSearched,   ,   .
   *!*	           (ON  OFF)  SET EXACT.
   *!*	 EXACT   ON,           .
   *!*	 EXACT    OFF,       ,        .      ,      SET EXACT.
   *!*	!
   *!*	       .
   *!*	 ,       nStartRow,   nRowsSearched  ,
   *!*	      ,        .
   *!*	   ASORT( )       .
   *!*	    ASUBSCRIPT( )      ()   .
   *!*	   AELEMENT( ) ,            .
Function VITESCAN
   Parameter REFARRAY,QUECHERCHE,nColsSear,nStartRow,nRowsSear
   Private All
   External Array REFARRAY
   If Parameters()>=3
      If Type('nColsSear')<>'N'
         Wait Windows "   "
         Return 0
         * nColsSear=1
      Endif
   Else
      nColsSear=1
   Endif
   If Parameters()>=4
      If Type('nStartRow')<>'N'
         Wait Windows "    (    )"
         Return 0
         * nStartRow=1
      Endif
      If nStartRow = -1
         nStartRow = 1  &&       
      Else
         If  .Not.Between(nStartRow, 1, Alen(REFARRAY,1))
            Wait Windows "    (    )"
            Return 0
         Endif
      Endif
   Else
      nStartRow=1
   Endif
   If Parameters()=5
      If Type('nRowsSear')<>'N'
         Wait Windows "    (     )"
         Return 0
      Endif
      If nRowsSear = -1
         nRowsSear = Alen(REFARRAY,1) - nStartRow + 1   &&   -           
      Else
         If  nRowsSear > Alen(REFARRAY,1) - nStartRow + 1
            nRowsSear = Alen(REFARRAY,1) - nStartRow + 1
         Endif
         If nRowsSear < -1 .Or. nRowsSear = 0
            Wait Windows "    (     )"
            Return 0
         Endif
      Endif
   Else
      nRowsSear=Alen(REFARRAY,1)-nStartRow+1
   Endif
   If Alen(REFARRAY,1)<nStartRow+nRowsSear-1
      **       
      nRowsSear=Alen(REFARRAY,1)-nStartRow+1
   Endif
   If Empty(Alen(REFARRAY,2))
      **  
      nColsSear=0
   Endif

   *       ASORT()    St_Denis_Russian.chm  "", "   ..."
   *  ,  Set Exact On,       ,
   *         ,   , ASCII    32.
   *            Set Exact On,   ASCAN()
   If Type('QUECHERCHE')=='C' And Empty(Len(Alltrim(QUECHERCHE))) And Set("EXACT") == "ON"
      Return Ascan( REFARRAY, QUECHERCHE, nStartRow, nRowsSear, Iif(Empty(nColsSear), -1, nColsSear) , 8)
   Endif
   PNF=BSEARCH(@REFARRAY,(QUECHERCHE),(nColsSear),(nStartRow),(nRowsSear))
   SPNF=PNF
   Do While .Not.Empty(PNF)
      PNF=PNF-nStartRow
      If PNF=0
         Exit
      Endif
      PNF=BSEARCH(@REFARRAY,(QUECHERCHE),(nColsSear),(nStartRow),(PNF))
      If .Not.Empty(PNF)
         SPNF=PNF
      Endif
   Enddo
   Return SPNF

Function BSEARCH
   Lparameter REFARRAY,QUECHERCHE,nColsSear,nStartRow,nRowsSear
   Private All
   External Array REFARRAY
   Low=nStartRow
   High=nStartRow+nRowsSear-1
   MID=Int((Low+High)/2)
   Do While  Low<=High
      Do Case
      Case Iif(Empty(Alen(REFARRAY,2)),.Not.Empty(Ascan(REFARRAY,QUECHERCHE,MID,1)),.Not.Empty(Ascan(REFARRAY,QUECHERCHE,Aelement(REFARRAY,MID,nColsSear),1)))
         Exit
      Case Iif(Empty(Alen(REFARRAY,2)),REFARRAY(MID),REFARRAY(MID,nColsSear))<=QUECHERCHE
         **  Low MID+      Low  High
         Low=MID+1
      Case Iif(Empty(Alen(REFARRAY,2)),REFARRAY(MID),REFARRAY(MID,nColsSear))>QUECHERCHE
         **  High MID-      Low  High
         High=MID-1
      Case Iif(Empty(Alen(REFARRAY,2)),Empty(Ascan(REFARRAY,QUECHERCHE,MID,1)),Empty(Ascan(REFARRAY,QUECHERCHE,Aelement(REFARRAY,MID,nColsSear),1)))
         Exit
      Otherwise
      Endcase
      MID=Int((Low+High)/2)
      If .Not.Between(MID,nStartRow,nStartRow+nRowsSear-1)
         Exit
      Endif
   Enddo
   If .Not.Between(MID,nStartRow,nStartRow+nRowsSear-1)
      MID=0
   Else
      If Iif(Empty(Alen(REFARRAY,2)),Empty(Ascan(REFARRAY,QUECHERCHE,MID,1)),Empty(Ascan(REFARRAY,QUECHERCHE,Aelement(REFARRAY,MID,nColsSear),1)))
         MID=0
      Endif
   Endif
   Return MID
   *------------------------       ---------------------------------


   *-----------------------------------------------------------
   *--  Chrtran2       Chrtran, 
   *--    Chrtran     "-"   ,
   *--     
   *-- , "A-Z"      A  Z
   *-----------------------------------------------------------
Function Chrtran2
   Lparameters cSearchedExpression, cSearchExpression, cReplacementExpression
   cSearchExpression = StrPreparation(cSearchExpression)
   cReplacementExpression = StrPreparation(cReplacementExpression)
   Return  Chrtran(cSearchedExpression, cSearchExpression, cReplacementExpression)

   *-----------------------------------------------------------
   *--  StrFilter2    tcString  ,     tcFilter.
   *--    StrFilter      "-"  ,
   *--   
   *-- , "A-Z"      A  Z
   *-----------------------------------------------------------
Function StrFilter2
   Lparameters tcString, tcFilter
   tcFilter = StrPreparation(tcFilter)
   Return  Chrtran(tcString, tcFilter + tcString, tcFilter)

   *-----------------------------------------------------------
   *--     StrFilter2   Chrtran2
   *--      [1-9]   [123456789]
   *--     [z-a]   [zyxwvutsrqponmlkjihgfedcba]
   *--      255 
   *-----------------------------------------------------------
Function StrPreparation
   Lparameters tcFilter
   Local All
   lcFilter = ''
   For I = 1 To Len(tcFilter)
      lcChar = Substr(tcFilter, I, 1)
      If lcChar == [-] And I>1 And I<Len(tcFilter)
         lcBeg = Substr(tcFilter, I-1, 1)
         lcEnd = Substr(tcFilter, I+1, 1)
         Do Case
         Case lcEnd > lcBeg
            For j = Asc(lcBeg)+1 To Asc(lcEnd)-1
               lcFilter = lcFilter + Chr(j)
            Endfor
         Case lcEnd < lcBeg
            For j = Asc(lcBeg)-1 To Asc(lcEnd)+1 Step -1
               lcFilter = lcFilter + Chr(j)
            Endfor
         Endcase
         If lcEnd == [-]
            I = I + 1 &&     "--"    "-"    
            lcFilter = lcFilter + lcEnd
         Endif
      Else
         lcFilter = lcFilter + lcChar
      Endif
   Endfor
   Return Left(lcFilter,Min(Len(lcFilter), 255))

   *-----------------------------------------------------------
   *--  StrFilter    tcString  ,     tcFilter.
   *-----------------------------------------------------------
Function StrFilter
   Lparameters tcString, tcFilter
   Return  Chrtran(tcString, tcFilter + tcString, tcFilter)


   *-----------------  /   ---------------------
   #Define LASTROMANNUMBER 3999
   #Define ROMANNUMERALS "IVXLCDM"
   #Define WRONGROMANNUMBER -1

   *!* I V X  L  C   D   M
   *!* 1 5 10 50 100 500 1000

   *!*	ArabToRoman()           
   *!*	ArabToRoman( tNum)    Character
   *!*	 tNum Numeric, Character
   *!*	:
   *!*	?ArabToRoman(3888) &&  MMMDCCCLXXXVIII
Function ArabToRoman
   Lparameters tNum
   If .Not.Inlist(Type("tNum"), "N", "C")
      Return "Wrong type of parameter, must be 'N' or 'C'"
   Endif
   If Inlist(Type("tNum"), "C")
      tNum = Val(tNum)
   Endif
   Local lnI, lnNum, lResult
   If Between(tNum, 1, 3999)
      tNum = Alltrim(Str(Int(tNum)))
      lResult = ""
      For lnI = Len(tNum) To 1 Step -1
         lnNum = Val(Substr(tNum, Len(tNum)-lnI+1, 1))
         lResult = lResult + ;
            iif(Version(5) < 900, Iif(lnNum < 4, Replicate(Substr(ROMANNUMERALS, lnI*2 - 1, 1),lnNum ),;
            iif(lnNum = 4 Or lnNum = 9, Substr(ROMANNUMERALS, lnI*2 - 1, 1)+Substr(ROMANNUMERALS, lnI*2 + Iif( lnNum = 9, 1, 0), 1),;
            substr(ROMANNUMERALS, lnI*2, 1)+Replicate(Substr(ROMANNUMERALS, lnI*2 - 1, 1),lnNum -5) )),;
            icase(lnNum < 4, Replicate(Substr(ROMANNUMERALS, lnI*2 - 1, 1),lnNum ),;
            lnNum = 4 Or lnNum = 9, Substr(ROMANNUMERALS, lnI*2 - 1, 1)+Substr(ROMANNUMERALS, lnI*2 + Iif( lnNum = 9, 1, 0), 1),;
            substr(ROMANNUMERALS, lnI*2, 1)+Replicate(Substr(ROMANNUMERALS, lnI*2 - 1, 1),lnNum -5) ))
      Endfor
   Else
      lResult = 'Out of range, must be between 1 and 3999'
   Endif
   Return lResult


   *!*	RomanToArab()     
   *!*	RomanToArab( tcRomanNumber)    Numeric
   *!*	 tcRomanNumber Character  
   *!*	:
   *!*	?RomanToArab('MDCCCLXXXVIII') &&  1888
Function RomanToArab
   Lparameters tcRomanNumber
   If .Not.Inlist(Type("tcRomanNumber"), "C")
      Return "Wrong type of parameter, must be 'C'"
   Endif
   Local lnI, lnJ, lnK, lnDelim, lcRomanNumber, lnResult
   tcRomanNumber = Upper(tcRomanNumber)
   lcRomanNumber = ""
   For lnI = 1 To Len(tcRomanNumber)
      If Substr(tcRomanNumber, lnI, 1)$ROMANNUMERALS
         lcRomanNumber = lcRomanNumber + Substr(tcRomanNumber, lnI, 1)
      Else
         If .Not.Isblank(Substr(tcRomanNumber, lnI, 1))
            Return WRONGROMANNUMBER
         Endif
      Endif
   Endfor
   lnResult = 0
   lnK = Len(lcRomanNumber)
   For lnI = 1 To 4
      If Empty(lnK)
         Exit
      Endif
      lnDelim = 10**(lnI-1)
      Do Case
      Case Substr(lcRomanNumber, lnK - 1, 2) == (Substr(ROMANNUMERALS, lnI*2 - 1, 1)+Substr(ROMANNUMERALS, lnI*2, 1)) && CD or XL or IV
         lnResult = lnResult + 4*lnDelim
         lnK = lnK - 2
      Case Substr(lcRomanNumber, lnK - 1, 2) == (Substr(ROMANNUMERALS, lnI*2 - 1, 1)+Substr(ROMANNUMERALS, (lnI+1)*2 - 1, 1)) && CM or XC or IX
         lnResult = lnResult + 9*lnDelim
         lnK = lnK - 2
      Otherwise
         For lnJ = 1 To 3  && MMM or CCC or XXX or III
            If Substr(lcRomanNumber, lnK, 1) == Substr(ROMANNUMERALS, lnI*2 - 1, 1)
               lnResult = lnResult + lnDelim
               lnK = lnK - 1
            Endif
         Endfor
         If Empty(lnK)
            Exit
         Endif
         If Substr(lcRomanNumber, lnK, 1) == Substr(ROMANNUMERALS, lnI*2, 1) && D or L or V
            lnResult = lnResult + 5*lnDelim
            lnK = lnK - 1
         Endif
      Endcase
   Endfor
   Return Iif(Empty(lnK), Iif(.Not.Empty(lnResult), lnResult, 0), WRONGROMANNUMBER)

   *!*	AddRomanNumbers()   
   *!*	   , ,          
   *!*	AddRomanNumbers(tcRomanNumber1, tcRomanNumber2, tcOperator)
   *!*	Return Values Character
   *!*	 tcRomanNumber1 Character   
   *!*	tcRomanNumber2 Character    , tcOperator Character  
   *!*	:
   *!*	?AddRomanNumbers('I','I', '+')                            &&  II
   *!*	?AddRomanNumbers('MMMDCCCLXXXVIII','MDCCCLXXXVIII','-')   &&  MM
Function AddRomanNumbers
   Lparameters tcRomanNumber1, tcRomanNumber2, tcOperator
   If Parameters() = 2
      tcOperator = "+"
   Else
      If .Not.Inlist(Type("tcOperator"), "C")
         Return "Wrong type of third parameter, must be 'C'"
      Endif
      If .Not. tcOperator $ "+,-,*,/,**"
         Return "Wrong third parameter, must be '+','-','*','/','**'"
      Endif
   Endif
   Local lnN1, lnN2
   lnN1 = RomanToArab(tcRomanNumber1)
   If lnN1 < 0
      Return 'Wrong first roman number'
   Endif
   lnN2 = RomanToArab(tcRomanNumber2)
   If lnN2 < 0
      Return 'Wrong second roman number'
   Endif
   Return (ArabToRoman(lnN1 &tcOperator lnN2))
