*!*	          memo .
*!*	    memo  14   employee  MakeKeyWordsFromAllMemoField
*!*	  0.05 ,     1 400 000 ,     .

Set Library To St_Denis Additive
Set Safety Off

Close Database
Open Database (Home(2) + 'data\testdata') Noupdate
Use employee In 0 Noupdate


lnBegTime = Seconds()
*    memo    employee
lcMaxLenAllWord  = MakeKeyWordsFromAllMemoField([employee], [keywordsemployee])
*    memo        employee
* lcMaxLenAllWord  = MakeKeyWordsFromAllMemoField([employee], [keywordsemployee], '', [Between(Recno(),5,10)])
?[Maximal lenght of all words is ], lcMaxLenAllWord
?[performance is ],  Seconds() - lnBegTime, [ seconds ]

Release Library St_Denis

Select keywordsemployee
Browse



*!*  MakeKeyWordsFromAllMemoField           
Function MakeKeyWordsFromAllMemoField
   Lparameters tcInputTableName,  tcOutputTableName, tcMemoFieldName, tcForClause
   *!*	tcInputTableName - ,  memo     
   *!*	tcOutputTableName - ,      
   *!*	tcMemoFieldName -  memo    tcInputTableName,     
   *!*	tcForClause -     tcInputTableName,    ,    
   *!*	  
   *!*	nRecno          tcInputTableName
   *!*	WORDNUM         memo 
   *!*	Word   - 
   *!*	STARTWORD       memo ,    
   Create Table (tcOutputTableName) Free  (nRecno N(12), WORDNUM N(6), Word C(50), STARTWORD N(6))
   Select (tcInputTableName)
   If Empty(tcForClause) Or Type('tcForClause') <> 'C'
      tcForClause = '.T.'
   Endif
   Local All
   If Empty(tcMemoFieldName) Or Type('tcMemoFieldName') <> 'C'
      Afields(laFields)
      * if this parameter is not valid
      * we are looking for a first memo field in the table
      For lnI = 1 To Alen(laFields,1)
         If laFields(lnI, 2) = [M]
            tcMemoFieldName = laFields(lnI, 1)
            Exit
         Endif
      Endfor
   Endif
   If Empty(tcMemoFieldName) Or Type('tcMemoFieldName') <> 'C'
      Return 'Memo field does not exists !'
   Endif
   tcMemoFieldName = '@'+tcMemoFieldName
   lcUniqArrayName = Sys(2015)
   lcDelimiters = [ ,.:;<>|+-_-*&^$%#@~!?"'(){}/]+Chr(10)+Chr(13)+Chr(9) &&     memo 
   lcMaxLenAllWord  = 0
   Scan For Evaluate(tcForClause)
      lcMaxLenWord  = GETALLWORDS(lcUniqArrayName, &tcMemoFieldName, lcDelimiters) &&   GETALLWORDS   St_Denis_Russian.chm
      If lcMaxLenWord > 0
         lcMaxLenAllWord  = Max(lcMaxLenAllWord, lcMaxLenWord)
         m->nRecno = Recno()
         Select (tcOutputTableName)
         Append From Array (lcUniqArrayName) Fields WORDNUM, Word, STARTWORD
         Go (Reccount() - Alen((lcUniqArrayName),1) + 1)
         Replace nRecno With m->nRecno Rest
      Endif
   Endscan
   Release (lcUniqArrayName)
   Return lcMaxLenAllWord
